JspCompilationContext (Tomcat API Documentation)
Keywords: org.apache.jasper.JspCompilationContext class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.jasper
Class JspCompilationContext

    java.lang.Object
      org.apache.jasper.JspCompilationContext

    public class JspCompilationContext

extends java.lang.Object

A place holder for various things that are used through out the JSP engine. This is a per-request/per-context data structure. Some of the instance variables are set at different points. Most of the path-related stuff is here - mangling names, versions, dirs, loading resources and dealing with uris.

Author:
  Anil K. Vijendran, Harish Prabandham, Pierre Delisle, Costin Manolache, Kin-man Chung

Field Summary
`protected java.lang.String` | `basePackageName`
`protected java.lang.String` | `baseURI`
`protected java.net.URL` | `baseUrl`
`protected java.lang.String` | `classFileName`
`protected java.lang.String` | `className`
`protected java.lang.String` | `classPath`
`protected java.lang.String` | `contentType`
`protected javax.servlet.ServletContext` | `context`
`protected java.lang.String` | `derivedPackageName`
`protected boolean` | `isErrPage`
`protected boolean` | `isPackagedTagFile`
`protected boolean` | `isTagFile`
`protected java.lang.String` | `javaPath`
`protected Compiler` | `jspCompiler`
`protected java.net.URLClassLoader` | `jspLoader`
`protected java.lang.String` | `jspUri`
`protected JspServletWrapper` | `jsw`
`protected java.net.URLClassLoader` | `loader`
`protected Log` | `log`
`protected Options` | `options`
`protected java.lang.String` | `outputDir`
`protected boolean` | `protoTypeMode`
`protected JspRuntimeContext` | `rctxt`
`protected int` | `removed`
`protected java.lang.Class` | `servletClass`
`protected java.lang.String` | `servletJavaFileName`
`protected java.net.URL` | `tagFileJarUrl`
`protected java.util.Map<java.lang.String,java.net.URL>` | `tagFileJarUrls`
`protected javax.servlet.jsp.tagext.TagInfo` | `tagInfo`
`protected ServletWriter` | `writer`

Constructor Summary
`JspCompilationContext(java.lang.String jspUri, boolean isErrPage, Options options, javax.servlet.ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt)`
`JspCompilationContext(java.lang.String tagfile, javax.servlet.jsp.tagext.TagInfo tagInfo, Options options, javax.servlet.ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt, java.net.URL tagFileJarUrl)`

Method Summary
`protected static java.lang.String` | `canonicalURI(java.lang.String s)`
`void` | `checkOutputDir()`
`void` | `compile()`
`Compiler` | `createCompiler()` Create a "Compiler" object based on some init param data.
`protected Compiler` | `createCompiler(java.lang.String className)`
`protected void` | `createOutputDir()`
`java.lang.String` | `getClassFileName()`
`java.lang.ClassLoader` | `getClassLoader()` What class loader to use for loading classes while compiling this JSP?
`java.lang.String` | `getClassPath()` The classpath that is passed off to the Java compiler.
`Compiler` | `getCompiler()`
`java.lang.String` | `getContentType()` Get the content type of this JSP.
`protected java.lang.String` | `getDerivedPackageName()`
`java.lang.String` | `getJavaPath()` Path of the Java file relative to the work directory.
`java.lang.String` | `getJspFile()` Path of the JSP URI.
`java.lang.ClassLoader` | `getJspLoader()`
`Options` | `getOptions()` Get hold of the Options object for this context.
`java.lang.String` | `getOutputDir()` The output directory to generate code into.
`java.lang.String` | `getRealPath(java.lang.String path)` Gets the actual path of a URI relative to the context of the compilation.
`java.net.URL` | `getResource(java.lang.String res)`
`java.io.InputStream` | `getResourceAsStream(java.lang.String res)` Gets a resource as a stream, relative to the meanings of this context's implementation.
`java.util.Set` | `getResourcePaths(java.lang.String path)`
`JspRuntimeContext` | `getRuntimeContext()`
`java.lang.String` | `getServletClassName()` Just the class name (does not include package name) of the generated class.
`javax.servlet.ServletContext` | `getServletContext()`
`java.lang.String` | `getServletJavaFileName()` Full path name of the Java file into which the servlet is being generated.
`java.lang.String` | `getServletPackageName()` Package name for the generated class is make up of the base package name, which is user settable, and the derived package name.
`java.net.URL` | `getTagFileJarUrl()` Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.
`java.net.URL` | `getTagFileJarUrl(java.lang.String tagFile)` Returns the tag-file-name-to-JAR-file map of this compilation unit, which maps tag file names to the JAR files in which the tag files are packaged.
`javax.servlet.jsp.tagext.TagInfo` | `getTagInfo()`
`java.lang.String[]` | `getTldLocation(java.lang.String uri)` Gets the 'location' of the TLD associated with the given taglib 'uri'.
`ServletWriter` | `getWriter()` Where is the servlet being generated?
`void` | `incrementRemoved()`
`boolean` | `isErrorPage()` Are we processing something that has been declared as an errorpage?
`protected static boolean` | `isPathSeparator(char c)`
`boolean` | `isPrototypeMode()` True if we are compiling a tag file in prototype mode.
`boolean` | `isRemoved()`
`boolean` | `isTagFile()`
`boolean` | `keepGenerated()` Are we keeping generated code around?
`java.lang.Class` | `load()`
`protected boolean` | `makeOutputDir()`
`java.lang.String` | `resolveRelativeUri(java.lang.String uri)` Get the full value of a URI relative to this compilations context uses current file as the base.
`void` | `setClassLoader(java.net.URLClassLoader loader)`
`void` | `setClassPath(java.lang.String classPath)` The classpath that is passed off to the Java compiler.
`void` | `setContentType(java.lang.String contentType)`
`void` | `setErrorPage(boolean isErrPage)`
`void` | `setPrototypeMode(boolean pm)`
`void` | `setServletClassName(java.lang.String className)`
`void` | `setServletPackageName(java.lang.String servletPackageName)` The package name into which the servlet class is generated.
`void` | `setTagFileJarUrl(java.lang.String tagFile, java.net.URL tagFileURL)`
`void` | `setTagInfo(javax.servlet.jsp.tagext.TagInfo tagi)`
`void` | `setWriter(ServletWriter writer)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### log

    protected Log log

### tagFileJarUrls

    protected java.util.Map<java.lang.String,java.net.URL> tagFileJarUrls

### isPackagedTagFile

    protected boolean isPackagedTagFile

### className

    protected java.lang.String className

### jspUri

    protected java.lang.String jspUri

### isErrPage

    protected boolean isErrPage

### basePackageName

    protected java.lang.String basePackageName

### derivedPackageName

    protected java.lang.String derivedPackageName

### servletJavaFileName

    protected java.lang.String servletJavaFileName

### javaPath

    protected java.lang.String javaPath

### classFileName

    protected java.lang.String classFileName

### contentType

    protected java.lang.String contentType

### writer

    protected ServletWriter writer

### options

    protected Options options

### jsw

    protected JspServletWrapper jsw

### jspCompiler

    protected Compiler jspCompiler

### classPath

    protected java.lang.String classPath

### baseURI

    protected java.lang.String baseURI

### outputDir

    protected java.lang.String outputDir

### context

    protected javax.servlet.ServletContext context

### loader

    protected java.net.URLClassLoader loader

### rctxt

    protected JspRuntimeContext rctxt

### removed

    protected int removed

### jspLoader

    protected java.net.URLClassLoader jspLoader

### baseUrl

    protected java.net.URL baseUrl

### servletClass

    protected java.lang.Class servletClass

### isTagFile

    protected boolean isTagFile

### protoTypeMode

    protected boolean protoTypeMode

### tagInfo

    protected javax.servlet.jsp.tagext.TagInfo tagInfo

### tagFileJarUrl

    protected java.net.URL tagFileJarUrl

Constructor Detail

### JspCompilationContext

    public JspCompilationContext(java.lang.String jspUri,
                                 boolean isErrPage,
                                 Options options,
                                 javax.servlet.ServletContext context,
                                 JspServletWrapper jsw,
                                 JspRuntimeContext rctxt)

### JspCompilationContext

    public JspCompilationContext(java.lang.String tagfile,
                                 javax.servlet.jsp.tagext.TagInfo tagInfo,
                                 Options options,
                                 javax.servlet.ServletContext context,
                                 JspServletWrapper jsw,
                                 JspRuntimeContext rctxt,
                                 java.net.URL tagFileJarUrl)

Method Detail

### getClassPath

    public java.lang.String getClassPath()

  The classpath that is passed off to the Java compiler.

### setClassPath

    public void setClassPath(java.lang.String classPath)

  The classpath that is passed off to the Java compiler.

### getClassLoader

    public java.lang.ClassLoader getClassLoader()

  What class loader to use for loading classes while compiling this JSP?

### setClassLoader

    public void setClassLoader(java.net.URLClassLoader loader)

### getJspLoader

    public java.lang.ClassLoader getJspLoader()

### getOutputDir

    public java.lang.String getOutputDir()

  The output directory to generate code into. The output directory is make up of the scratch directory, which is provide in Options, plus the directory derived from the package name.

### createCompiler

    public Compiler createCompiler()
                            throws JasperException

  Create a "Compiler" object based on some init param data. This is not done yet. Right now we're just hardcoding the actual compilers that are created.

  Throws:
    `JasperException`

### createCompiler

    protected Compiler createCompiler(java.lang.String className)

### getCompiler

    public Compiler getCompiler()

### resolveRelativeUri

    public java.lang.String resolveRelativeUri(java.lang.String uri)

  Get the full value of a URI relative to this compilations context uses current file as the base.

### getResourceAsStream

    public java.io.InputStream getResourceAsStream(java.lang.String res)

  Gets a resource as a stream, relative to the meanings of this context's implementation.

  Returns:
    a null if the resource cannot be found or represented as an InputStream.

### getResource

    public java.net.URL getResource(java.lang.String res)
                             throws java.net.MalformedURLException

  Throws:
    `java.net.MalformedURLException`

### getResourcePaths

    public java.util.Set getResourcePaths(java.lang.String path)

### getRealPath

    public java.lang.String getRealPath(java.lang.String path)

  Gets the actual path of a URI relative to the context of the compilation.

### getTagFileJarUrl

    public java.net.URL getTagFileJarUrl(java.lang.String tagFile)

  Returns the tag-file-name-to-JAR-file map of this compilation unit, which maps tag file names to the JAR files in which the tag files are packaged. The map is populated when parsing the tag-file elements of the TLDs of any imported taglibs.

### setTagFileJarUrl

    public void setTagFileJarUrl(java.lang.String tagFile,
                                 java.net.URL tagFileURL)

### getTagFileJarUrl

    public java.net.URL getTagFileJarUrl()

  Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.

### getServletClassName

    public java.lang.String getServletClassName()

  Just the class name (does not include package name) of the generated class.

### setServletClassName

    public void setServletClassName(java.lang.String className)

### getJspFile

    public java.lang.String getJspFile()

  Path of the JSP URI. Note that this is not a file name. This is the context rooted URI of the JSP file.

### isErrorPage

    public boolean isErrorPage()

  Are we processing something that has been declared as an errorpage?

### setErrorPage

    public void setErrorPage(boolean isErrPage)

### isTagFile

    public boolean isTagFile()

### getTagInfo

    public javax.servlet.jsp.tagext.TagInfo getTagInfo()

### setTagInfo

    public void setTagInfo(javax.servlet.jsp.tagext.TagInfo tagi)

### isPrototypeMode

    public boolean isPrototypeMode()

  True if we are compiling a tag file in prototype mode. ie we only generate codes with class for the tag handler with empty method bodies.

### setPrototypeMode

    public void setPrototypeMode(boolean pm)

### getServletPackageName

    public java.lang.String getServletPackageName()

  Package name for the generated class is make up of the base package name, which is user settable, and the derived package name. The derived package name directly mirrors the file heirachy of the JSP page.

### getDerivedPackageName

    protected java.lang.String getDerivedPackageName()

### setServletPackageName

    public void setServletPackageName(java.lang.String servletPackageName)

  The package name into which the servlet class is generated.

### getServletJavaFileName

    public java.lang.String getServletJavaFileName()

  Full path name of the Java file into which the servlet is being generated.

### getOptions

    public Options getOptions()

  Get hold of the Options object for this context.

### getServletContext

    public javax.servlet.ServletContext getServletContext()

### getRuntimeContext

    public JspRuntimeContext getRuntimeContext()

### getJavaPath

    public java.lang.String getJavaPath()

  Path of the Java file relative to the work directory.

### getClassFileName

    public java.lang.String getClassFileName()

### getContentType

    public java.lang.String getContentType()

  Get the content type of this JSP. Content type includes content type and encoding.

### setContentType

    public void setContentType(java.lang.String contentType)

### getWriter

    public ServletWriter getWriter()

  Where is the servlet being generated?

### setWriter

    public void setWriter(ServletWriter writer)

### getTldLocation

    public java.lang.String[] getTldLocation(java.lang.String uri)
                                      throws JasperException

  Gets the 'location' of the TLD associated with the given taglib 'uri'.

  Returns:
    An array of two Strings: The first element denotes the real path to the TLD. If the path to the TLD points to a jar file, then the second element denotes the name of the TLD entry in the jar file. Returns null if the given uri is not associated with any tag library 'exposed' in the web application.
  Throws:
    `JasperException`

### keepGenerated

    public boolean keepGenerated()

  Are we keeping generated code around?

### incrementRemoved

    public void incrementRemoved()

### isRemoved

    public boolean isRemoved()

### compile

    public void compile()
                 throws JasperException,
                        java.io.FileNotFoundException

  Throws:
    `JasperException`
    `java.io.FileNotFoundException`

### load

    public java.lang.Class load()
                         throws JasperException,
                                java.io.FileNotFoundException

  Throws:
    `JasperException`
    `java.io.FileNotFoundException`

### checkOutputDir

    public void checkOutputDir()

### makeOutputDir

    protected boolean makeOutputDir()

### createOutputDir

    protected void createOutputDir()

### isPathSeparator

    protected static final boolean isPathSeparator(char c)

### canonicalURI

    protected static final java.lang.String canonicalURI(java.lang.String s)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.